"use strict";

this.name        = "yah_ad_service"; 
this.author      = "spara";
this.description = "Pooling ad service";

this.$adPool = [];
this.$brokenAdPool = [];

//public function for adding horizontal ad to pool. the parameter is the filename of the ad.
this._setAd = function(ad) {
  this.$adPool.push(ad);
}

this._setBrokenAd = function(ad) {
  this.$brokenAdPool.push(ad);
}

this.startUpComplete = function() {
  if (this.$adPool.length > 0) {  
    //shuffle the pool
    this.$adPool = this._shuffle(this.$adPool);
      
    //Pools are divided to two parts to prevent the same ad to be seen in a quick succession. Pools are split into two parts and a primary part is randomly selected. When the active part is emptied, then the secondary part is used. When that is emptied too, pool is initialized and we draw from the primary part again.

    this._initPool();
    this.$primary = Math.round(Math.random());
  }
  //in case no ad-packs are installed, always return a dummy ad.
  else this._getAd = this._noAds;
}

this._shuffle = function(pool) {
  var shuffled = new Array();
  var poolSize = pool.length;
  for (var i = poolSize; i > 0; i--) {
    shuffled.push(pool.splice(Math.floor(Math.random() * i), 1)[0]);
  }
  return shuffled;
}

this._initPool = function() {
	var poolSize = this.$adPool.length;
  this.$pool = [this.$adPool.slice(0, Math.floor(poolSize / 2)), this.$adPool.slice(Math.ceil(poolSize / 2), poolSize - 1)];
}

//public function that returns a random ad filename from the pool
this._getAd = function() {
  if (this.$pool[this.$primary].length === 0) {
    this.$primary = (this.$primary + 1) % 2;
    if (this.$pool[this.$primary].length === 0) {
      this._initPool();
    };
  };
  var adNum = Math.floor(Math.random() * this.$pool[this.$primary].length);
  return this.$pool[this.$primary].splice(adNum, 1)[0];
}

this._noAds = function() {
  return "yah_billboard_ad.png";
}

//public function that returns a random broken ad filename from the broken ad pool
this._getBrokenAd = function() {
  return this.$brokenAdPool[Math.floor(Math.random() * this.$brokenAdPool.length)];
}
